%define name krb5-fermi-config
%define path /usr/krb5
%define version 2.8
%define release 1

Summary: Configuration scripts to get Fermize your Kerberos Machine
Name: %{name}
Version: %{version}
Release: %{release}
Source0: %{name}-%{version}.tar.gz
Copyright: MIT, freely distributable.
URL: http://web.mit.edu/kerberos/www/
Prereq: fileutils krb5-workstation-fermi
Group: Fermi
BuildArchitectures: noarch
Packager: Troy Dawson <dawson@fnal.gov>
BuildRoot: %{_tmppath}/%{name}-%{version}

%description
Kerberos V5 is a trusted-third-party network authentication system,
which can improve your network's security by eliminating the insecure
practice of cleartext passwords.
The config set's up config files so that a machine is ready to
be in Fermilab's kerberos realm

%prep
%setup
rm -rf $RPM_BUILD_ROOT

%install
install -m 0755 -d $RPM_BUILD_ROOT/etc
install -m 0755 -d $RPM_BUILD_ROOT/etc/sysconfig
install -m 0755 -d $RPM_BUILD_ROOT/%{path}/config
install -m 0755 -d $RPM_BUILD_ROOT/%{path}/man
install -m 0755 -d $RPM_BUILD_ROOT/%{path}/man/man5

install -m 0744 config-krb5.conf.aklog $RPM_BUILD_ROOT/%{path}/config/config-krb5.conf.aklog
install -m 0744 config-krb5.conf $RPM_BUILD_ROOT/%{path}/config/config-krb5.conf
install -m 0744 config-inetd.conf $RPM_BUILD_ROOT/%{path}/config/config-inetd.conf
install -m 0744 config-xinetd $RPM_BUILD_ROOT/%{path}/config/config-xinetd
install -m 0744 config-services $RPM_BUILD_ROOT/%{path}/config/config-services
install -m 0744 config-sshd_config $RPM_BUILD_ROOT/%{path}/config/config-sshd_config
install -m 0744 config-hostkeys $RPM_BUILD_ROOT/%{path}/config/config-hostkeys
install -m 0744 config-hostkeys $RPM_BUILD_ROOT/%{path}/config/makehostkeys
install -m 0644 inetd.conf.template $RPM_BUILD_ROOT/%{path}/config/inetd.conf.template
install -m 0644 inetd.conf.wrapped.template $RPM_BUILD_ROOT/%{path}/config/inetd.conf.wrapped.template
install -m 0644 krb5.conf.template $RPM_BUILD_ROOT/%{path}/config/krb5.conf.template
install -m 0644 services.template $RPM_BUILD_ROOT/%{path}/config/services.template
install -m 0644 sshd_config.template $RPM_BUILD_ROOT/%{path}/config/sshd_config.template
install -m 0644 sshd_config.weak.template $RPM_BUILD_ROOT/%{path}/config/sshd_config.weak.template
install -m 0644 xinetd.template $RPM_BUILD_ROOT/%{path}/config/xinetd.template
install -m 0644 ftp.xinetd $RPM_BUILD_ROOT/%{path}/config/ftp.xinetd
install -m 0644 telnet.xinetd $RPM_BUILD_ROOT/%{path}/config/telnet.xinetd
install -m 0644 klogin.xinetd $RPM_BUILD_ROOT/%{path}/config/klogin.xinetd
install -m 0644 eklogin.xinetd $RPM_BUILD_ROOT/%{path}/config/eklogin.xinetd
install -m 0644 kshell.xinetd $RPM_BUILD_ROOT/%{path}/config/kshell.xinetd
install -m 0644 ftp.xinetd.on $RPM_BUILD_ROOT/%{path}/config/ftp.xinetd.on
install -m 0644 telnet.xinetd.on $RPM_BUILD_ROOT/%{path}/config/telnet.xinetd.on
install -m 0644 klogin.xinetd.on $RPM_BUILD_ROOT/%{path}/config/klogin.xinetd.on
install -m 0644 eklogin.xinetd.on $RPM_BUILD_ROOT/%{path}/config/eklogin.xinetd.on
install -m 0644 kshell.xinetd.on $RPM_BUILD_ROOT/%{path}/config/kshell.xinetd.on
install -m 0644 krb.conf $RPM_BUILD_ROOT/etc/krb.conf.fermi
install -m 0644 krb5.conf.aklog $RPM_BUILD_ROOT/etc/sysconfig/krb5.conf.aklog

install -m 0644 man/keytab-convert.5 $RPM_BUILD_ROOT/%{path}/man/man5/keytab-convert.5
install -m 0644 man/krb5conf.5 $RPM_BUILD_ROOT/%{path}/man/man5/krb5conf.5

%post 
if [ -f /etc/krb5.conf ] ; then
	echo "We need a fresh krb5.conf, moving old krb5.conf to /etc/krb5.conf.save.%{name}.%{version}.%{release}"
	mv /etc/krb5.conf /etc/krb5.conf.save.%{name}.%{version}.%{release}
fi
%{path}/config/config-krb5.conf %{version}
if [ -f /etc/krb.conf ] ; then
	echo "Fixing /etc/krb.conf"
	if ! [ -s /etc/krb.conf.save.%{name}.%{version}.%{release} ] ; then
		mv -f /etc/krb.conf /etc/krb.conf.save.%{name}.%{version}.%{release}
	fi
	cp -f /etc/krb.conf.fermi /etc/krb.conf
fi
if [ -f /etc/inetd.conf ] ; then
	%{path}/config/config-inetd.conf %{version}
fi
if [ -d /etc/xinetd.d ] ; then
	%{path}/config/config-xinetd %{version}
fi
%{path}/config/config-services %{version}
if [ -f /etc/sshd_conf ] ; then
	%{path}/config/config-sshd_config %{version}
fi
echo "Your computer has been configured to run kerberos"
echo "If you need a host priciple you should run '%{path}/config/makehostkeys'"

%preun
if [ "$1" = "0" ] ; then
	echo "We are in the pre-un and running"
fi

%triggerin -- krb5-workstation
if [ -d /etc/xinetd.d ] ; then
	%{path}/config/config-xinetd %{version} >> /tmp/fermi.krb5.config.xinetd
fi

%triggerin -- openafs, openafs-thiscell
%{path}/config/config-krb5.conf.aklog

%triggerpostun -- openafs, openafs-thiscell
%{path}/config/config-krb5.conf.aklog

%triggerin -- krbafs
if [ -f /etc/krb.conf ] ; then
	if ! [ -s /etc/krb.conf.save.%{name}.%{version}.%{release} ] ; then
		mv -f /etc/krb.conf /etc/krb.conf.save.%{name}.%{version}.%{release}
	fi
	cp -f /etc/krb.conf.fermi /etc/krb.conf
fi


%triggerpostun -- krb5-workstation
if [ -d /etc/xinetd.d ] ; then
	%{path}/config/config-xinetd %{version} >> /tmp/fermi.krb5.config.xinetd
fi


%files
%dir %{path}
%dir %{path}/config
%dir %{path}/man
%{path}/man/man5

%{path}/config/config-krb5.conf
%{path}/config/config-krb5.conf.aklog
%{path}/config/config-inetd.conf
%{path}/config/config-xinetd
%{path}/config/config-services
%{path}/config/config-sshd_config
%{path}/config/config-hostkeys
%{path}/config/makehostkeys
%{path}/config/inetd.conf.template
%{path}/config/inetd.conf.wrapped.template
%{path}/config/krb5.conf.template
%{path}/config/services.template
%{path}/config/sshd_config.template
%{path}/config/sshd_config.weak.template
%{path}/config/xinetd.template
%{path}/config/ftp.xinetd
%{path}/config/telnet.xinetd
%{path}/config/klogin.xinetd
%{path}/config/eklogin.xinetd
%{path}/config/kshell.xinetd
%{path}/config/ftp.xinetd.on
%{path}/config/telnet.xinetd.on
%{path}/config/klogin.xinetd.on
%{path}/config/eklogin.xinetd.on
%{path}/config/kshell.xinetd.on
/etc/krb.conf.fermi
%config(noreplace) /etc/sysconfig/krb5.conf.aklog

%changelog
* Fri Jun 27 2008 Troy Dawson <dawson@fnal.gov> 2.8-1
- Updated to version 2.8
- kept the ignore_afs change

* Thu Oct 25 2007 Troy Dawson <dawson@fnal.gov> 2.7a-1
- Removed the "ignore_afs = true" from the pam section

* Mon Aug 27 2007 Troy Dawson <dawson@fnal.gov> 2.7.1
- Updated to krb5.conf 2.7 - fixing cryptocard problems

* Mon Aug 08 2007 Troy Dawson <dawson@fnal.gov> 2.5-4
- Made it generic, to work with both SLF3 and SLF4

* Mon Aug 08 2007 Troy Dawson <dawson@fnal.gov> 2.5-3
- Updated the name to match the krb5.conf version - 2.5
- updated the config script to say 2.5
- Made it so that it moves the old krb5.conf out of the way

* Mon Jul 02 2007 Troy Dawson <dawson@fnal.gov> 1.25-1.LTS4
- updated the krb5.conf.template file to version 1.25
- Changed makekeys so that it finds the right kadmin

* Wed Jun 27 2007 Troy Dawson <dawson@fnal.gov> 1.24a-1.LTS4
- updated the krb5.conf.template file to version 1.24a

* Tue Oct 03 2006 Troy Dawson <dawson@fnal.gov> 1.16-1.LTS4
- updated the krb5.conf.template file to version 1.16

* Thu Aug 31 2006 Troy Dawson <dawson@fnal.gov> 1.15-1.LTS4
- updated the krb5.conf.template file to version 1.15

* Fri Aug 05 2005 Troy Dawson <dawson@fnal.gov> 1.10-1.LTS4
- updated the krb5.conf.template file to version 1.10

* Tue Nov 02 2004 Troy Dawson <dawson@fnal.gov> 1.9-4.LTS
- added config-krb5.conf.aklog and /etc/sysconfig/krb5.conf.aklog
- added triggers to run config-krb5.conf.aklog with AFS triggers

* Fri Oct 01 2004 Troy Dawson <dawson@fnal.gov> 1.9-3.LTS
- fixed script that says it's 1.8a
- made the rpm a noarch

* Wed Sep 28 2004 Troy Dawson <dawson@fnal.gov> 1.9-1.LTS
- updated to 1.9

* Tue Apr 06 2004 Troy Dawson <dawson@fnal.gov>
- added .sdsc.edu to the FNAL.GOV realm

* Tue Apr 06 2004 Troy Dawson <dawson@fnal.gov>
- added .sdsc.edu to the FNAL.GOV realm

* Fri Apr 02 2004 Troy Dawson <dawson@fnal.gov>
- Changed krb5.conf.template to put PAM section at top.

* Mon Feb 09 2004 Troy Dawson <dawson@fnal.gov>
- Fixed it so that it no longer moves the current krb5.conf out of the way
if it does not have to.

* Fri Jan 16 2004 Troy Dawson <dawson@fnal.gov>
- Updated to krb5conf 1.8a

* Tue Nov 11 2003 Troy Dawson <dawson@fnal.gov>
- Put back in the krb.conf, but with proper settings, and triggers

* Tue Oct 04 2003 Troy Dawson <dawson@fnal.gov>
- Cleaned out krb.conf so it quits messing things up.

* Tue Oct 04 2003 Troy Dawson <dawson@fnal.gov>
- Converted to krb5conf 1.7.  I had missed a few things the first time

* Thu Sep 25 2003 Troy Dawson <dawson@fnal.gov>
- Added triggers for the xinetd configs

* Mon Apr 07 2003 Troy Dawson <dawson@fnal.gov>
- Took out the check that took krb.conf completely out.

* Wed Apr 02 2003 Troy Dawson <dawson@fnal.gov>
- Took /etc/krb.conf out

* Fri Aug 09 2002 Troy Dawson <dawson@fnal.gov>
- Changed the requires, put in a check before it does ssh config

* Fri May 24 2002 Troy Dawson <dawson@fnal.gov>
- Fixed a bug in the krb5.conf template (removed two 4's)

* Tue May 07 2002 Troy Dawson <dawson@fnal.gov>
- Made changes to the config xinetd script

* Mon May 06 2002 Troy Dawson <dawson@fnal.gov>
- Configured to use the krb5conf v1_6 stuff

* Thu Oct 25 2001 Troy Dawson <dawson@fnal.gov>
- Changed spec file so that it moves the /etc/krb5.conf file

* Thu Oct 25 2001 Troy Dawson <dawson@fnal.gov>
- Changed the krb5.conf.template file so that the Pam part was first, 
also lengthened ticket time
- Edited the spec file so that it doesn't automatically move the /etc/krb5.conf file

* Tue Oct 2 2001 Troy Dawson <dawson@fnal.gov>
- Made changes for pam usage in krb.conf and krb5.conf
- Also removed the linking of /usr/krb5 and /usr/kerberos

* Mon Aug 27 2001 Troy Dawson <dawson@fnal.gov>
- Upgraded from krb5conf 1.5.  Also put in changes for xinetd.

* Tue Jun 12 2001 Troy Dawson <dawson@fnal.gov>
- Made improvements to the makehostkeys script.  I also have it check 
  for the varias files (sshd_config, services) before modifying them.

* Tue Jun 5 2001 Troy Dawson <dawson@fnal.gov>
- The config-inetd.conf script has been changed to look for services
  that have a kerberos equal.  If these services were originally turned
  off, then the kerberized version is turned off.  I also took out the
  keytab-convert program, as this is dependant on one particular flavor
  of fermi kerberos.

* Tue May 22 2001 Troy Dawson <dawson@fnal.gov>
- I added the keytab-convert program into the config rpm, with it's
  corresponding manpage.  It will also be in the normal kerberos rpm
  but in the bin area.

* Mon May 21 2001 Troy Dawson <dawson@fnal.gov>
- I changed things to the version 1.4.  I also added the config-sshd_config
  script, as well as the config-hostkeys script.

* Wed May 9 2001 Troy Dawson <dawson@fnal.gov>
- I finished with the config-services and config-inetd.conf scripts.
  I also changed how the /usr/krb5 and /usr/kerberos were linked.

* Wed May 2 2001 Troy Dawson <dawson@fnal.gov>
- I put the raw scripts into the package from Fermi.  These will
  need to be rewritten so that they don't depend on Fermi packages.

